	program VanRaden
      implicit none

      include "blk.incl"

	integer*4 i, j, k, n, ngm
	character*128 str,sor,jour
	integer*4 sire(nt),dam(nt),ped(2,nt), point(nt),po(nt)
      integer*4 ord(nt),rord(nt)
      integer*2 nge(nt)
	real*8    f(nt)

      include "format.incl"

      call fdate(jour)
      PRINT 990,jour

      print 1001
      read(5,*) str
      print 1002,str
      ngm=0
      print 1003
      read(5,*) sor
      print 1004,sor
      print 6001
      read(5,*,end=9) ngm
      if (ngm.gt.0) print 6002,ngm
    9 if (ngm.eq.0) print 6003

      n=0
      open (1,file=str,form='FORMATTED')
      open (2,file=sor,form='FORMATTED')
    1 read (1,*,end=2) i,j,k
	n=n+1
      if (i.ne.n) then
        print 102,n,i
        stop
        end if
	if (i.gt.nt.or.j.gt.nt.or.k.gt.nt) then
        print 101
        stop
        end if
	sire(n)=j
	dam(n)=k
	goto 1
    2 print 900,n
	close(1)

	call comp_d
     *   (n, sire, dam, ped, f, ord,rord,point,po,nge,ngm)
      close(2)
	stop
	end


	subroutine comp_d (n,sire, dam,ped,f,ord,rord,point,po,nge,ngm)
      implicit none
      integer*4 n,sire(*),dam(*),ped(2,*),nbit,k,i,ngm
      integer*4 ord(*), rord(*),point(*),po(*),j,n_stat_f
      real*8   stat_f(100),f(*)
      integer*2 nge(*)

      include "format.incl"

	nbit=0
	do i=1, n
	  ord(i)=0
	  end do
	k=0
	do while (nbit.lt.50.and.k.lt.n)
	  nbit=nbit + 1
c	  if (nbit.eq.50) print *,' subroutine comp_d: nbit>50'
	  do i=1, n
	    if (ord(i).eq.0) then
		if (sire(i).le.0 .or. ord(sire(i)).ne.0) then
		if (dam(i) .le.0 .or. ord( dam(i)).ne.0) then
		  k=k+1
		  ord(i)=k
                rord(k)=i
		  end if
		  end if
		end if
	    end do
c          print *, 'recod', nbit, n, k
	  end do

      if (k.lt.n) then
         print 6004,n-k
         do i=1, n
           if (ord(i).eq.0) then
             sire(i)=-1
             dam(i)=-1
             k=k+1
             ord(i)=k
             rord(k)=i
             end if
           end do
         end if

      do i=1, n
	  j=rord(i)
	  ped(1,i)=sire(j)
	  ped(2,i)=dam(j)
	  if (ped(1,i).gt.0) ped(1,i)=ord(sire(j))
	  if (ped(2,i).gt.0) ped(2,i)=ord(dam(j))
        end do

	call vanrad(n, ped, f, point, po,nge,ngm)

      call bin_f(n, f, stat_f)
      DO I=1,n
          if (f(ord(i)).gt.0.d0) write (2,'(i8,f10.5)') i,f(ord(i))
c          print *,i,sire(i),dam(i),f(ord(i))
          end do
	return
	end

C*** Methode de VanRaden
      subroutine vanrad(n, ped, f, point,po,nge,ngm)
      implicit none

      include "blk.incl"

	integer*4 ped(2,*),point(*),po(*),nii
      integer*4 i,j,k,ks,kd,jv,pv,mv,np1,jp,jm,ja,n,np,ngm,npm,ii,jj
      real*8    a(nig:nam,nig:nam), f(*),fint(nam), x
      integer*4 vec(nam),npp(nam),pe(2,nam)
      integer*2 nge(*),ngt(nam)
c      real*4    t1,t2,gtimer
c      external  gtimer
      logical   test
      character*128 jour

      include "format.incl"

c      t1=gtimer()
      test=.false.
      npm=0
      if (ngm.ne.0) test=.true.
      nii=0
      DO i=1,n
        if (i.le.ped(1,i) .or. i.le.ped(2,i)) then
	    print *,'Probleme dans le codage du pedigree'
          print *,i, ped(1,i),ped(2,i)
          stop
          end if
        point(i)=0
        f(i)=-1.d0
        ks=ped(1,i)
        kd=ped(2,i)
        ped(1,i)=max(ks,kd)
        ped(2,i)=min(ks,kd)
        if (ped(2,i).lt.nii) nii=ped(2,i)
	nge(i)=-1
        end do

c groupe et ngm non nuls sont deux options incompatibles
      if (test) then
        nii=0
        do i=1,n
          if (ped(1,i).lt.0) ped(1,i)=0
          if (ped(2,i).lt.0) ped(2,i)=0
          end do
        end if
      print 6006,nii*(-1)
      if (nii.lt.nig) stop 'augmenter nig / increase parameter nig'

      do i=1,nam
        npp(i)=0
        a(0,i)=0.d0
        a(i,0)=0.d0
        end do
      a(0,0)=0.d0
      if (nii.lt.0) then
        do i=nii,nam
          do j=nii,-1
            a(i,j)=0.d0
            a(j,i)=0.d0
            end do
          end do
c prise en compte de la consanguinite de base
   11   read (5,*, end=12) i,x
        if (i.ge.nii.and.i.le.0) then
          print 6007,i,x
          x=2.d0*x
          a(i,i)=x
c propagation des valeurs initiales
          do j=nii,i-1
            a(i,j)=x
            a(j,i)=x
            end do
          end if
          goto 11
   12   close (5)
        end if

      DO i=n,1,-1
c        if (mod(i,10000).eq.0) print *,i
        ks=ped(1,i)
        kd=ped(2,i)
        if (ks.le.0.and.kd.le.0) then
           f(i)=.5d0*a(ks,kd)
        else if (.not.test .and. f(i).ge.0.d0) then
        else
          np=0
          j=i
          nge(i)=0
          do while(j.ne.0)
            k=j
            ks=ped(1,k)
            kd=ped(2,k)
c prise en compte de ngm generations seulement
            if (test) then
	      jj=nge(j)+1	  
              if (ks.ne.0) then  
                if (nge(ks).lt.0) then
                   nge(ks)=jj
                else if (jj.lt.nge(ks)) then
                  nge(ks)=jj
                  end if
                end if
              if (kd.ne.0) then
                 if (nge(kd).lt.0) then
                   nge(kd)=jj
                else if (jj.lt.nge(kd)) then
                  nge(kd)=jj
                  end if
                end if
              end if

            if (ks.gt.0) then
              do while(point(k).gt.ks)
                k=point(k)
                end do
              if (ks.ne.point(k)) then
                point(ks)=point(k)
                point(k)=ks
                end if
              if (kd.gt.0) then
                do while(point(k).gt.kd)
                  k=point(k)
                  end do
                if (kd.ne.point(k)) then
                  point(kd)=point(k)
                  point(k)=kd
                  end if
                end if
              end if
            np=np+1
            if (np.gt.nam) then
               print 6008,i,nam
               stop
               end if
            vec(np)=j
            pe(1,np)=ks
            pe(2,np)=kd
            po(j)=np
            k=j
            j=point(j)
            point(k)=0
            end do
          npp(np)=npp(np) + 1
          if (npm.lt.np) npm=np

c limitation a n generations
          if (test) then
	    ii=0 ; jj=0
	    do j=1, np
	      jv=vec(j)
	      if (nge(jv).le.ngm) then
	        ii=ii+1
		vec(ii)=vec(j)
		pe(1,ii)=pe(1,j)
		pe(2,ii)=pe(2,j)
		po(jv)=ii
		ngt(ii)=nge(jv)
	      else 
	        jj=jj+1
		end if
	      nge(jv)=-1
	      end do
            np=ii
c	    if (jj.gt.0) then
	      do j=1, np
	        k=po(pe(1,j))
	        if (k.gt.np.or.vec(k).ne.pe(1,j)) then
	          pe(1,j)=0
		else if (ngt(j).eq.ngm.and.ngt(k).ge.ngm) then
		  pe(1,j)=0
		  end if
		  
	        k=po(pe(2,j))
	        if (k.gt.np.or.vec(k).ne.pe(2,j)) then
		  pe(2,j)=0
	        else if (ngt(j).eq.ngm.and.ngt(k).ge.ngm) then
		  pe(2,j)=0
		  end if    		
	        end do
c              end if

c            if (i.eq.33) then
c	      print *,'individu',i
c              do j=1, np
c	         print *,j,vec(j),pe(1,j),pe(2,j),ngt(j),po(j)
c	         end do
c	       end if

	    end if
	  
	  
c construction  de A pour l individu i	  
          np1=np+1
          do j=1, np
            jv=np1-j
            ja=vec(jv)
            jp=pe(1,jv)
            jm=pe(2,jv)
            if (jp.gt.0) then
              pv=np1-po(jp)
            else
              pv=jp
              end if
            if (jm.gt.0) then
              mv=np1-po(jm)
            else
              mv=jm
              end if
            jv=j-1
            do k=nii,jv
              a(j,k)= .5d0 * (a(pv,k) + a(mv,k))
              a(k,j)=a(j,k)
              end do
            fint(j)= .5d0*a(pv,mv)
            a(j,j)=1.d0 + fint(j)
            end do
	    
	   if (test) then
	     f(i)=fint(np)
	   else 
	     do j=1, np
	       ja=vec(j)
	       f(ja)=fint(np1-j)
	       end do
	     end if  

          end if
        end do
       print 6009,npm
c      print *,'Nb ancetres   Effectif'
c      do i=1, na
c        if (npp(i).gt.0) then
c            print 500,i,npp(i)
c        end if

c       t2=gtimer()
c       print *,'Temps cpu : ', t2-t1

       RETURN
       END

c ... stat de consanguinite
      subroutine bin_f (n,f,stat_f)
      implicit none
      integer i,j,n,dim,ii,nin
      parameter (dim = 23)
      real*8  f(*), total
      real*8  stat_f (dim), maxf
      character*128 jour

      include "format.incl"

c..   computing statistics for inbreeding.

      do i = 1, dim
         stat_f (i) = 0.d0
      end do

      maxf = 0.d0
      nin = 0
      total = 0.d0
      do i = 1, n
         ii = int(f(i) * 20.d0 + 1.d0)
         if (ii.gt.20) ii = 20
         if (f(i) .lt. 0.0000001d0) f(i) = 0.d0
         if (f(i).ne.0.d0) then
            nin = nin + 1
            total = total + f(i)
            if (f(i).gt.maxf) maxf = f(i)
            stat_f (ii) = stat_f (ii) + 1
         end if
      end do

      stat_f (21) = nin
      if (nin.gt.0) then
         stat_f (22) = total * 100.d0/ dfloat(nin)
      end if
      stat_f (23) = maxf  * 100.d0
      print 3100,n,nin,stat_f(22),stat_f(23)
      do i=1,20
        if (stat_f(i).gt.0.d0)
     *       print '(2i8,f10.0)',(i-1)*5,(i*5),stat_f(i)
        end do

      call fdate(jour)
      PRINT 991,jour
      return
      end
